unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, ADODB, StdCtrls;

type
  TForm1 = class(TForm)
    Connection: TADOConnection;
    MasterDS: TDataSource;
    DetailDS: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    MasterSQL: TADODataSet;
    DetailSQL: TADODataSet;
    StCmButton: TButton;
    RollbackButton: TButton;
    procedure StCmButtonClick(Sender: TObject);
    procedure RollbackButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    procedure fix_controls;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.fix_controls;
begin
    if Connection.InTransaction then
        begin
           StCmButton.Caption := 'Commit';
           RollbackButton.Enabled := True;
        end
    else
        begin
           StCmButton.Caption := 'Begin';
           RollbackButton.Enabled := False;
        end;
    MasterSQL.Requery;
    DetailSQL.Requery;
end;

procedure TForm1.StCmButtonClick(Sender: TObject);
begin
    if not Connection.InTransaction
          then Connection.BeginTrans
          else Connection.CommitTrans;
    fix_controls;
end;

procedure TForm1.RollbackButtonClick(Sender: TObject);
begin
    Connection.RollbackTrans;
    fix_controls;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
    fix_controls;
end;

end.
